<?php

namespace Wutime\AdBlock\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;
use XF\Service;

class JavaScript extends Entity
{
     static $default_foldername = 'wutime_adblock';

     public static function getStructure(Structure $structure)
	{
          $structure->table      = 'xf_wutime_adblock';
          $structure->shortName  = 'AdBlock:JavaScript';
          $structure->primaryKey = 'entity_id';

          $structure->columns = [
               'entity_id'              => ['type' => self::UINT, 'autoIncrement' => true],
               'status' => ['type'      => self::STR, 
                            'default'   => 'New',
                            'allowedValues' => ['Default','Old','New']],
               'path'              => ['type' => self::STR, 'maxlength' => 255],
               'foldername'        => ['type' => self::STR, 'maxlength' => 60],
               'filename'          => ['type' => self::STR, 'maxlength' => 60],
               'js_key'            => ['type' => self::STR, 'maxlength' => 60],
               'js_detect_file'    => ['type' => self::STR, 'maxlength' => 60],
               'created'           => ['type' => self::UINT, 'default' => \XF::$time]
          ];

          return $structure;
     }

     protected function _preDelete()
     {
          if (file_exists($this->path))  {
               if ($this->foldername != self::$default_foldername) {
                    \XF\Util\File::deleteDirectory($this->path);
               }
          }
     }
}